﻿Imports System.Windows.Media.Animation

Class MainWindow

    Dim Kreis As MoveCircle

    Private Sub Window_Loaded(sender As Object, e As RoutedEventArgs)
        Kreis = New MoveCircle(Raster, 20, 50, Height / 2, Width - 30)
    End Sub

    Private Sub button_Click(sender As Object, e As RoutedEventArgs) Handles button.Click
        Kreis.Show()
        label.Content = "Fläche = " + CStr(Kreis.Flaeche())
        label1.Content = "Umfang = " + CStr(Kreis.Umfang())
    End Sub

    Private Sub button1_Click(sender As Object, e As RoutedEventArgs) Handles button1.Click
        Kreis.Move()
    End Sub

    Private Sub button2_Click(sender As Object, e As RoutedEventArgs) Handles button2.Click
        Kreis.Hide()
        label.Content = ""
        label1.Content = ""
    End Sub

End Class


Class MoveCircle
    Private Oval As New Ellipse()
    Private x, y, Dicke, Strecke As Integer
    Private Raster As Grid

    Public Sub New(rr As Grid, xx As Integer, yy As Integer, dd As Integer, ss As Integer)
        ' Startwerte für die Eigenschaften 
        Raster = rr : x = xx : y = yy
        Dicke = dd : Strecke = ss
        ' Startwerte für den Kreis
        Oval.Width = Dicke : Oval.Height = Dicke
        Oval.Margin = New Thickness(x, y, 0, 0)
        Oval.Stroke = Brushes.Black
        Oval.Fill = Brushes.Red
        Oval.HorizontalAlignment = HorizontalAlignment.Left
        Oval.VerticalAlignment = VerticalAlignment.Top
        Oval.Visibility = Visibility.Hidden
        ' ins Raster einfügen
        Raster.Children.Add(Oval)
    End Sub

    Public Sub Show()
        Oval.Visibility = Visibility.Visible
    End Sub

    Public Sub Move()
        Dim animation As New ThicknessAnimation()
        animation.From = New Thickness(x, y, 0, 0)
        animation.To = New Thickness(Strecke - Dicke, y, 0, 0)
        animation.Duration = New Duration(TimeSpan.FromSeconds(2))
        Oval.BeginAnimation(Ellipse.MarginProperty, animation)
    End Sub

    Public Sub Hide()
        Oval.Visibility = Visibility.Hidden
    End Sub

    Public Function Flaeche() As Single
        Return Math.PI * (Dicke / 2) * (Dicke / 2)
    End Function

    Public Function Umfang() As Single
        Return Math.PI * Dicke
    End Function

End Class

