﻿Imports System.Windows.Media.Animation

Class MainWindow

    Dim Quadrat As MoveSquare

    Private Sub Window_Loaded(sender As Object, e As RoutedEventArgs)
        Quadrat = New MoveSquare(Raster, 20, 50, Height / 2, Width - 30)
    End Sub

    Private Sub button_Click(sender As Object, e As RoutedEventArgs) Handles button.Click
        Quadrat.Show()
        label.Content = "Fläche = " + CStr(Quadrat.Flaeche())
        label1.Content = "Umfang = " + CStr(Quadrat.Umfang())
    End Sub

    Private Sub button1_Click(sender As Object, e As RoutedEventArgs) Handles button1.Click
        Quadrat.Move()
    End Sub

    Private Sub button2_Click(sender As Object, e As RoutedEventArgs) Handles button2.Click
        Quadrat.Hide()
        label.Content = ""
        label1.Content = ""
    End Sub

End Class


Class MoveSquare
    Private Eck As New Rectangle()
    Private x, y, Dicke, Strecke As Integer
    Private Raster As Grid

    Public Sub New(rr As Grid, xx As Integer, yy As Integer, dd As Integer, ss As Integer)
        ' Startwerte für die Eigenschaften 
        Raster = rr : x = xx : y = yy
        Dicke = dd : Strecke = ss
        ' Startwerte für den Quadrat
        Eck.Width = Dicke : Eck.Height = Dicke
        Eck.Margin = New Thickness(x, y, 0, 0)
        Eck.Stroke = Brushes.Black
        Eck.Fill = Brushes.Green
        Eck.HorizontalAlignment = HorizontalAlignment.Left
        Eck.VerticalAlignment = VerticalAlignment.Top
        Eck.Visibility = Visibility.Hidden
        ' ins Raster einfügen
        Raster.Children.Add(Eck)
    End Sub

    Public Sub Show()
        Eck.Visibility = Visibility.Visible
    End Sub

    Public Sub Move()
        ' Verschiebung
        Dim animation As New ThicknessAnimation()
        animation.From = New Thickness(x, y, 0, 0)
        animation.To = New Thickness(Strecke - Dicke, y, 0, 0)
        animation.Duration = New Duration(TimeSpan.FromSeconds(2))
        Eck.BeginAnimation(Ellipse.MarginProperty, animation)
        ' Transparenz
        Dim animation1 As New DoubleAnimation()
        animation1.From = 1.0
        animation1.To = 0.6
        animation1.Duration = New Duration(TimeSpan.FromSeconds(2))
        Eck.BeginAnimation(Rectangle.OpacityProperty, animation1)
    End Sub

    Public Sub Hide()
        Eck.Visibility = Visibility.Hidden
    End Sub

    Public Function Flaeche() As Single
        Return Dicke * Dicke
    End Function

    Public Function Umfang() As Single
        Return 4 * Dicke
    End Function

End Class

