﻿Imports System.Windows.Threading

Public Class MoveImage : Inherits Image
    Protected x, y, Dicke, Strecke As Integer
    Protected Zeit As DispatcherTimer
    Private Raster As Grid

    Public Sub New(rr As Grid, xx As Integer, yy As Integer, dd As Integer, ss As Integer)
        ' Startwerte für die Eigenschaften 
        Raster = rr : x = xx : y = yy
        Dicke = dd : Strecke = ss
        ' Startwerte für das Bild
        Me.Width = Dicke : Me.Height = Dicke
        Me.Margin = New Thickness(x, y, 0, 0)
        Me.HorizontalAlignment = HorizontalAlignment.Left
        Me.VerticalAlignment = VerticalAlignment.Top
        Me.Visibility = Visibility.Hidden
        ' ins Raster einfügen
        Raster.Children.Add(Me)
        ' Zeitgeber erzeugen, mit Tick-Methode verknüpfen
        Zeit = New DispatcherTimer()
        AddHandler Zeit.Tick, AddressOf timer_Tick

    End Sub

    Public Sub Load(Datei As String)
        Try
            Me.Source = New BitmapImage(New Uri(Datei))
        Catch
        End Try
    End Sub

    Public Sub Show()
        Me.Visibility = Visibility.Visible
    End Sub

    Public Sub Move()
        ' Millisekunden
        Zeit.Interval = New TimeSpan(0, 0, 0, 0, 20)
        Zeit.Start()
    End Sub

    Public Sub Hide()
        Me.Visibility = Visibility.Hidden
    End Sub

    Private Sub timer_Tick(sender As Object, e As EventArgs)
        If x < Strecke - Dicke Then
            x += 10
        Else
            Zeit.Stop()
        End If
        Me.Margin = New Thickness(x, y, 0, 0)
    End Sub

End Class
