﻿Imports System.Windows.Media.Animation
Imports System.Windows.Threading

Public Class MoveImage : Inherits Image
    Protected x, y, Dicke, Strecke As Integer
    Private Raster As Grid

    Public Sub New(rr As Grid, xx As Integer, yy As Integer, dd As Integer, ss As Integer)
        ' Startwerte für die Eigenschaften 
        Raster = rr : x = xx : y = yy
        Dicke = dd : Strecke = ss
        ' Startwerte für das Bild
        Me.Width = Dicke : Me.Height = Dicke
        Me.Margin = New Thickness(x, y, 0, 0)
        Me.HorizontalAlignment = HorizontalAlignment.Left
        Me.VerticalAlignment = VerticalAlignment.Top
        Me.Visibility = Visibility.Hidden
        ' ins Raster einfügen
        Raster.Children.Add(Me)
    End Sub

    Public Sub Load(Datei As String)
        Try
            Me.Source = New BitmapImage(New Uri(Datei))
        Catch
        End Try
    End Sub

    Public Sub Show()
        Me.Visibility = Visibility.Visible
    End Sub

    Public Sub Move()
        Dim animation As New ThicknessAnimation()
        animation.From = New Thickness(x, y, 0, 0)
        animation.To = New Thickness(Strecke - Dicke, y, 0, 0)
        animation.Duration = New Duration(TimeSpan.FromSeconds(2))
        Me.BeginAnimation(Ellipse.MarginProperty, animation)
    End Sub

    Public Sub Hide()
        Me.Visibility = Visibility.Hidden
    End Sub

End Class


Public Class Movie : Inherits MoveImage
    Protected Zeit As DispatcherTimer
    Private DName As String
    Private Nr As Integer
    Private Modus As Boolean

    Public Sub New(rr As Grid, xx As Integer, yy As Integer, dd As Integer, ss As Integer)
        MyBase.New(rr, xx, yy, dd, ss)
        Me.Width = Dicke : Me.Height = 1.5 * Dicke
        ' Zeitgeber und Methode verknüpfen
        Zeit = New DispatcherTimer()
        AddHandler Zeit.Tick, AddressOf timer_Tick
        Modus = False
    End Sub

    Public Shadows Sub Load(Datei As String)
        DName = Datei
        MyBase.Load(Datei)
    End Sub

    Public Shadows Sub Move()
        Nr = 2 'nach rechts
        Modus = False 'nicht drehen
        ' Millisekunden
        Zeit.Interval = New TimeSpan(0, 0, 0, 0, 100)
        Zeit.Start()
    End Sub

    Public Sub Turn()
        Modus = True 'drehen
        ' Millisekunden
        Zeit.Interval = New TimeSpan(0, 0, 0, 0, 100)
        Zeit.Start()
    End Sub

    Private Sub timer_Tick(sender As Object, e As EventArgs)
        Dim Txt As String
        'Dateinamen bei Nummer "kappen"
        Txt = DName.Substring(0, DName.Length - 5)
        If Modus Then
            If Nr < 4 Then Nr += 1 : Else Nr = 1
        Else
            Select Case Nr
                Case 2 : Nr = 6
                Case 6 : Nr = 2
            End Select
            If x < Strecke - Dicke Then
                x += 20
            Else
                Zeit.Stop()
                Nr = 1
            End If
            Me.Margin = New Thickness(x, y, 0, 0)
        End If
        DName = Txt + CStr(Nr) + ".png"
        Load(DName)
    End Sub

End Class

