﻿Imports System.Windows.Media.Animation

Public Class TokenX : Inherits Token

    Protected Richtung As Integer

    Public Sub New(rr As Grid, xx As Integer, yy As Integer, dd As Integer, ww As Integer, hh As Integer)
        MyBase.New(rr, xx, yy, dd, ww, hh)
        Richtung = 0
    End Sub

    Public Sub Move(Taste As Key)
        Dim Drehung As Integer
        ' Drehung und Weg bestimmen
        Select Case Taste
            Case Key.Up
                If y > yOben Then y -= yDiff  ' nach oben
                Drehung = 0
            Case Key.Left
                If x > xLinks Then x -= xDiff  ' nach links
                Drehung = 1
            Case Key.Down
                If y < yUnten Then y += yDiff  ' nach unten
                Drehung = 2
            Case Key.Right
                If x < xRechts Then x += xDiff  ' nach rechts
                Drehung = 3
        End Select
        ' Figur ausrichten und bewegen
        Rotate(Richtung - Drehung)
        Richtung = Drehung
        Me.Margin = New Thickness(x, y, 0, 0)
    End Sub

    Protected Sub Rotate(dreh As Integer)
        Dim bild As New TransformedBitmap()
        ' Bild übernehmen
        bild.BeginInit()
        bild.Source = Me.Source
        ' Drehung festlegen
        bild.Transform = New RotateTransform(dreh * 90)
        bild.EndInit()
        ' Gedrehtes Bild zuweisen
        Me.Source = bild
    End Sub

End Class


Public Class TokenY : Inherits Token

    Protected Winkel As Double

    Public Sub New(rr As Grid, xx As Integer, yy As Integer, dd As Integer, ww As Integer, hh As Integer)
        MyBase.New(rr, xx, yy, dd, ww, hh)
        Winkel = 0
    End Sub

    Public Sub Move(xPos As Integer, yPos As Integer)
        ' Ziel ggf. korrigieren
        If xPos > xRechts Then xPos = xRechts
        If yPos > yUnten Then yPos = yUnten
        ' Figur passend drehen
        Rotate(xPos, yPos)
        ' Animation vorbereiten, Figur bewegen
        Dim animation As New ThicknessAnimation()
        animation.From = New Thickness(x, y, 0, 0)
        animation.To = New Thickness(xPos, yPos, 0, 0)
        animation.Duration = New Duration(TimeSpan.FromSeconds(1))
        Me.BeginAnimation(Image.MarginProperty, animation)
        ' neue Position merken
        x = xPos : y = yPos
    End Sub

    Protected Sub Rotate(xWeg As Integer, yWeg As Integer)
        ' Winkel berechnen
        Dim Grad As Double
        xWeg -= x : yWeg -= y
        Grad = Math.Atan2(xWeg, -yWeg) * 180 / Math.PI
        ' Animation vorbereiten, Figur ausrichten
        Dim animation As New DoubleAnimation()
        animation.From = Winkel
        animation.To = Grad
        animation.Duration = New Duration(TimeSpan.FromMilliseconds(200))
        ' um Mittelpunkt drehen
        Dim bild As New RotateTransform()
        bild.CenterX = Dicke / 2 : bild.CenterY = Dicke / 2
        ' Bild animieren
        bild.BeginAnimation(RotateTransform.AngleProperty, animation)
        Me.RenderTransform = bild
        ' neuen Winkel merken
        Winkel = Grad
    End Sub

End Class
